

class ExtraLife extends UT_Invisibility;

#exec mesh import mesh=ExtraLiveM anivfile=Models\ExtraLiveM_a.3d datafile=Models\ExtraLiveM_d.3d x=0 y=0 z=0 mlod=1 LODSTYLE=2
#exec mesh origin mesh=ExtraLiveM x=0 y=0 z=0
#exec mesh sequence mesh=ExtraLiveM seq=All startframe=0 numframes=1

#exec meshmap new meshmap=ExtraLiveM mesh=ExtraLiveM
#exec meshmap scale meshmap=ExtraLiveM x=0.09263 y=0.09263 z=0.18526

var() int bRespawnTime;
var() int ExtraLivesAwarded;
var() int LivesLimit;

state Activated
{
   function endstate()
   {
      local Inventory S;

      bActive = false;
      PlaySound(DeActivateSound);

      Owner.SetDefaultDisplayProperties();
      S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
      if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
         UT_Shieldbelt(S).MyEffect.bHidden = false;
   }

   function Activate()
   {
      bActive = true;

      SetOwnerDisplay();
   }

   function SetOwnerDisplay()
   {
   }

   function ChangedWeapon()
   {
   }

   function BeginState()
   {
      local Inventory S;

      bActive = true;
      PlaySound(ActivateSound,,4.0);
   }

   simulated function Tick(float DT)
	{
		local PlayerPawn P;
		local bool bRunOnce;

		P = PlayerPawn(Owner);

		Super.Tick(DT);
		if ( !bRunOnce )
		{
			if(P.PlayerReplicationInfo.Deaths < LivesLimit)
         	P.PlayerReplicationInfo.Deaths = (P.PlayerReplicationInfo.Deaths) + ExtraLivesAwarded;
         else
				P.ReceiveLocalizedMessage(class'ExtraLifeDeniedMessage');

         GoToState('DeActivated');
         bRunOnce = True;
         Destroy();
		}
	}
}

state DeActivated
{
	Begin:
}

State Sleeping
{
   ignores Touch;

   function BeginState()
   {
      BecomePickup();
      bHidden = true;
   }
   function EndState()
   {
      local int i;

      bSleepTouch = false;
      for ( i=0; i<4; i++ )
         if ( (Touching[i] != None) && Touching[i].IsA('Pawn') )
            bSleepTouch = true;
   }
Begin:
   Sleep( bReSpawnTime );
   PlaySound( RespawnSound );
   Sleep( Level.Game.PlaySpawnEffect(self) );
   GoToState( 'Pickup' );
}

defaultproperties
{
	DrawType=DT_Mesh
   PickupMessage="You got the Extra Life pickup!"
   ItemName="Extra Life"
   RespawnTime=90.000000
   PickupViewMesh=LodMesh'ExtraLiveM'
   PickupSound=Sound'BotPack.CTF.CaptureSound2'
   ActivateSound=None
   MultiSkins(0)=Texture'BotPack.Skins.jdeathmatchtrophy'
   MultiSkins(1)=Texture'BotPack.Skins.jdomination'
   Mesh=LodMesh'ExtraLiveM'
   CollisionRadius=13.000000
   CollisionHeight=25.000000
   bRotatingPickup=True
   RotationRate=(Yaw=10000)
   ExtraLivesAwarded=1
   LivesLimit=10
   Charge=10
   ExpireMessage="You can get another extra life now"
}
