class ImaHero extends UT_Invisibility;

var() int bRespawnTime;
var() int ExtraLivesAwarded;
var() int LivesLimit;
var() bool PunishMe;

state Activated
{
   function endstate()
   {
      local Inventory S;

      bActive = false;
      PlaySound(DeActivateSound);

      Owner.SetDefaultDisplayProperties();
      S = Pawn(Owner).FindInventoryType(class'UT_ShieldBelt');
      if ( (S != None) && (UT_Shieldbelt(S).MyEffect != None) )
         UT_Shieldbelt(S).MyEffect.bHidden = false;
   }

   function Activate()
   {
      bActive = true;

      SetOwnerDisplay();
   }

   function SetOwnerDisplay()
   {
   }

   function ChangedWeapon()
   {
   }

   function BeginState()
   {
      local Inventory S;

      bActive = true;
      PlaySound(ActivateSound,,4.0);
   }

   simulated function Tick(float DT)
	{
		local PlayerPawn PP;
		local bool bRunOnce;
		local Pawn P;
		local Vector X;

		PP = PlayerPawn(Owner);

		Super.Tick(DT);
		if ( !bRunOnce )
		{
		   if(PunishMe)
		   	PP.TakeDamage( 2000, Instigator, Location,(1000 * X),'gibbed' );

         For ( P=Level.PawnList; P!=None; P=P.nextPawn )
			{
         	if ( P.bIsPlayer && P != PP) //Self?
         	{
					if(P.PlayerReplicationInfo.Deaths < LivesLimit)
         			P.PlayerReplicationInfo.Deaths = (P.PlayerReplicationInfo.Deaths) + ExtraLivesAwarded;
					P.ReceiveLocalizedMessage(class'ImaHeroMessage');
				}
			}
						
         GoToState('DeActivated');
         bRunOnce = True;
         Destroy();
		}
	}
}

state DeActivated
{
	Begin:
}

State Sleeping
{
   ignores Touch;

   function BeginState()
   {
      BecomePickup();
      bHidden = true;
   }
   function EndState()
   {
      local int i;

      bSleepTouch = false;
      for ( i=0; i<4; i++ )
         if ( (Touching[i] != None) && Touching[i].IsA('Pawn') )
            bSleepTouch = true;
   }
Begin:
   Sleep( bReSpawnTime );
   PlaySound( RespawnSound );
   Sleep( Level.Game.PlaySpawnEffect(self) );
   GoToState( 'Pickup' );
}

defaultproperties
{
	DrawType=DT_Mesh
   PickupMessage="You were the Hero!"
   ItemName="Hero Relic"
   RespawnTime=90.000000
   PickupViewMesh=LodMesh'ExtraLiveM'
   PickupSound=Sound'BotPack.CTF.CaptureSound2'
   ActivateSound=None
   MultiSkins(0)=Texture'BotPack.Skins.jdeathmatchtrophy'
   MultiSkins(1)=Texture'BotPack.Skins.jdomination'
   Mesh=LodMesh'ExtraLiveM'
   CollisionRadius=13.000000
   CollisionHeight=25.000000
   bRotatingPickup=True
   RotationRate=(Yaw=10000)
   ExtraLivesAwarded=1
   LivesLimit=10
   PunishMe=True
   Charge=10
   ExpireMessage="You can get another extra life now"
}
